Description

=begin

The WIN32OLE library does not work when using Ruby threads. It may raise exceptions such as this:

(druby://localhost:2002) threadsys.rb:7:in connect': failed to parse display name of moniker winmgmts://localhost/root/cimv2'

(WIN32OLERuntimeError)

WIN32 OLE api's are not generally Thread safe, and it can be argued that it is the user's task to ensure that it is accessed only from

one thread, or the main thread. However, there are some complications;

Using WIN32OLE from DRb (DRb can not be used without Threads).

Using WIN32OLE indirectly (e.g. through Sys::ProcTable).

My specific case was a DRb server that examined processes using Sys::ProcTable, which happen to use WIN32OLE.  This causes

an exception. Attached is a simple script that recreates the problem. Note that in this simple case, WIN32OLE is only invokes once,

and only from one single thread (and it still throws the exception).

=end

History

#1 - 02/19/2011 06:19 AM - headius (Charles Nutter)

=begin

We struggled with this a bit on JRuby too while implementing win32ole. The contract under which we implemented it also called for high concurrency,

so we needed to figure out the right bits and pieces and threading models and so on.

Is it possible for you to try this with JRuby + jruby-win32ole gem? If it works, then what we did might help MRI.

=end

#2 - 02/23/2011 03:19 AM - rogerdpack (Roger Pack)

=begin

It does seem to work all right with jruby.

=end

#3 - 03/01/2011 03:12 AM - enebo (Thomas Enebo)

=begin

JRuby's implementation should be prone to the same problems when accessing an STA service from multiple threads.  The fact that it works should

probably be considered luck more than anything.  I agree with the original reporters statement that thread-safety is the users problem to work around.

One thing we could change in win32ole is the ability to specify that we want to access the service as MTA.  This would allow MT programs to work at

the extreme performance penalty that comes along with accessing a STA as MTA (100-1000x slower).  It doesn't crash and for many COM services

performance is not an issue.

=end

#4 - 03/01/2011 05:14 AM - larsch (Lars Christensen)

=begin

Charles Nutter wrote:

Is it possible for you to try this with JRuby + jruby-win32ole gem? If it works, then what we did might help MRI.

 Appears to work well with jruby 1.6.0.RC2 (ruby 1.8.7 patchlevel 330) & jruby-win32ole 0.8.3.

=end
#5 - 06/26/2011 05:52 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to suke (Masaki Suketa)

#6 - 02/26/2021 11:07 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Assigned to Closed

From my testing, this was fixed between Ruby 1.9.3 and Ruby 2.0, printing WIN32OLE object instead of raising an exception.  It still works on Ruby

3.0, so I think this can be closed.

Files

threadsys.rb 257 Bytes 02/17/2011 larsch (Lars Christensen)
